<template>
  <div
    v-show="!loading"
    id="app"
  >
    <app-mobile-banner
      :is-visible="isMobile && isShowMobileBanner"
      @update:is-visible="isShowMobileBanner = $event"
    />
    <div class="sm:block md:block lg:block">
      <router-view v-slot="{ Component }">
        <transition>
          <div>
            <component :is="Component" />
          </div>
        </transition>
      </router-view>

      <div id="teleport-modal" />
    </div>
  </div>
</template>

<script>
import { mapGetters, mapActions, mapState } from 'vuex';
import { useSessionStorage } from '@vueuse/core';
import AppResizePage from '@/modules/layout/pages/resize-page.vue';
import AppMobileBanner from '@/modules/layout/components/mobile-banner/mobile-banner.vue';
import { FeatureFlag } from '@/utils/featureFlag';
import config from '@/config';
import { AuthToken } from '@/modules/auth/auth-token';
import identify from '@/shared/monitoring/identify';

export default {
  name: 'App',

  components: {
    AppResizePage,
    AppMobileBanner,
  },

  data() {
    return {
      isShowMobileBanner: useSessionStorage('isShowMobileBanner', true),
    };
  },

  computed: {
    ...mapGetters({
      loadingInit: 'auth/loadingInit',
      currentTenant: 'auth/currentTenant',
      currentUser: 'auth/currentUser',
      isMobile: 'layout/isMobile',
    }),
    ...mapState({
      featureFlag: (state) => state.tenant.featureFlag,
    }),
    loading() {
      return (
        (this.loadingInit && !!AuthToken.get())
        || (!this.featureFlag.isReady
          && !this.featureFlag.hasError
          && !config.isCommunityVersion)
      );
    },
  },

  watch: {
    currentUser: {
      handler(user, oldUser) {
        if (user?.id && user.id !== oldUser?.id) {
          identify(user);
        }
      },
    },
  },

  beforeCreate() {
    this.$router.beforeEach((to, from, next) => {
      document.title = `GetSphere.dev${to.meta.title ? ` | ${to.meta.title}` : ''}`;
      next();
    });
  },

  async created() {
    await this.doInit();

    FeatureFlag.init(this.currentTenant);

    window.addEventListener('resize', this.handleResize);
    this.handleResize();
  },

  unmounted() {
    window.removeEventListener('resize', this.handleResize);
  },

  methods: {
    ...mapActions({
      doInit: 'auth/doInit',
      resize: 'layout/resize',
    }),

    handleResize() {
      this.resize({
        width: window.innerWidth,
        height: window.innerHeight,
      });
    },
  },
};
</script>

<style lang="scss">
@import 'assets/scss/index.scss';
</style>
